var timings = {};
var audiotags = [];
ELEMENTS_NUMBER = 70;
SOURCE = "glass.ogg";

function average(array) {
  var sum = 0;
  for(var i=0;i<array.length;i++)
    sum += array[i];
  return sum/array.length;
}

function sdev(array) {
  avg = average(array);
  dev = 0;
  for(var i = 0 ; i < array.length; i++) {
    dev += Math.pow((array[i] - avg), 2);
  }
  dev /= array.length;
  return Math.sqrt(dev);
}

function getColorString(value) {
  if(value <= 2) {
    return "rgb(100,100,200)";
  }
  value-=8;
  // on the contrary, > 100ms is horrible
  if(value >= 100) value = 100; 
  if(value <= 0) value = 0;
  var red = Math.round(Math.min(value / 100, 1) * 255);
  var green = Math.round((1 - Math.min(value / 100, 1)) * 255);
  var blue = 0;
  return "rgb("+red+","+green+","+blue+")";
}

// Write the results in the table.
var onPlaying = function (event) {
  event.target.removeEventListener("play", onPlaying);
  var target = event.target;
  var res = timings[target.id];
  var t = document.getElementById("t"+target.id),
      a = document.getElementById("a"+target.id),
      d = document.getElementById("d"+target.id);
  res.end = Date.now();
  var deltat = res.end - res.start;
  res.serie.push(deltat);
  t.innerHTML = deltat;
  t.style.background = getColorString(deltat);
  var avg = average(res.serie);
  a.innerHTML = avg;
  a.style.background = getColorString(avg);
  d.innerHTML = sdev(res.serie);
}

// Returns a row of the table.
var odd=false;
function create_row(id) {
  console.log("create row " + id);
  var root = document.createElement("tr");
  if(odd) {
    root.className = "odd";
  }
  odd = !odd;
  var track, status,current_run, avg, sdev;
  track = document.createElement("td");
  track.innerHTML=id;

  status = document.createElement("td");
  status.id = "r"+id;
  status.innerHTML="-";
  current_run = document.createElement("td");
  current_run.id = "t"+id;
  current_run.innerHTML="-";
  avg = document.createElement("td");
  avg.id = "a"+id;
  avg.innerHTML="-";
  sdev = document.createElement("td");
  sdev.id = "d"+id;
  sdev.innerHTML="-";
  root.appendChild(track);
  root.appendChild(status);
  root.appendChild(current_run);
  root.appendChild(avg);
  root.appendChild(sdev);
  return root;
}

// Creates the audio elements, and the table.
function init() {
  audioTagsContainer = document.getElementById("audiotags");
  resultTable = document.getElementById("results");
  var proto = new Audio(SOURCE);
  proto.load();
  for(var i = 0; i < ELEMENTS_NUMBER; i++) {
    audiotags[i] = new Audio(SOURCE);
    audiotags[i].mozLoadFrom(proto);
    audiotags[i].load();
    audiotags[i].id = "track"+i;
    audiotags[i].controls = false;
    audiotags[i].addEventListener("canplaythrough", function(e) {
        setstatus(e.target.id, "loaded");
        }, false);

    audiotags[i].addEventListener("ended", function(e) {
        setstatus(e.target.id, "ready");
        }, false);
    audioTagsContainer.appendChild(audiotags[i]);
    resultTable.appendChild(create_row(audiotags[i].id));
  }
  var tags = document.getElementsByTagName("audio");
  for(var i= 0; i < tags.length; i++) {
    timings[tags[i].id] = {
start:null,
      end: null,
      serie : []
    };
    tags[i].addEventListener("play", onPlaying, false);
  }
}

function setstatus(track, msg) {
  document.getElementById("r" + track).innerHTML = msg;
}

// Program the play() calls, and start the timers.
function trigger() {
  var tags = document.getElementsByTagName("audio");
  for(var i= 0; i < tags.length; i++) {
    tags[i].pause();
    tags[i].addEventListener("play", onPlaying, false);
  }

  function play(audio) {
    audio.play();
    timings[audio.id].start = Date.now();
    document.getElementById("r" + audio.id).innerHTML = "playing";
  }

  for(var i = 0; i < ELEMENTS_NUMBER; i++) {
    setTimeout( play, i*200, document.getElementById("track"+i) );
  }
}
